// createApp(App).mount('#app')
import { createApp } from 'vue'
import App from './App.vue'
import router from './router'
import '@fortawesome/fontawesome-free/css/all.css'
import 'bootstrap/dist/css/bootstrap.css'
import 'bootstrap'
import 'toastr/build/toastr.css'
import toastr from 'toastr'
import UserPermissions from './permissions.js'

// Configura Toastr
toastr.options = {
  closeButton: true,
  progressBar: true,
  positionClass: 'toast-top-right',
  timeOut: 3000
};

const app = createApp(App);
app.use(UserPermissions)
app.use(router);
app.config.globalProperties.$toastr = toastr;
app.mount('#app');